global gFloatName, gParadePartsList, gMaskName, gCostumeName

on CreateFloatAnimation
  if gFloatName = #aquaFloat then
    set currentFloat to the number of member "Aqua Float Loop"
  else
    if gFloatName = #cosmosFloat then
      set currentFloat to the number of member "Cosmos Float Loop"
    else
      if gFloatName = #tropicanaFloat then
        set currentFloat to the number of member "Tropical Float Loop"
      end if
    end if
  end if
  set returnFrame to the frame
  CreateScoreRange(the floatChannel of gParadePartsList, 0, point(447, 129), point(-228, 129), currentFloat, label("Float start"), label("Float end"), 1)
  go(returnFrame)
end

on DeleteFloatFromScore
  set returnFrame to the frame
  DeleteScoreRange([the floatChannel of gParadePartsList], label("Float start"), label("Float end"), 1)
  go(returnFrame)
end

on CreateCaptainAnimation
  set returnFrame to the frame
  set headMember to member "Costume Mannequin" of castLib "Internal"
  CreateScoreRange(the headChannel of gParadePartsList, 8, point(103, 245), point(103, 89), headMember, label("Captain start"), label("Captain waving"), 1)
  CreateScoreRange(the headChannel of gParadePartsList, 8, point(103, 89), point(103, 89), headMember, label("Captain waving"), label("Captain leaving"), 1)
  CreateScoreRange(the headChannel of gParadePartsList, 8, point(103, 89), point(103, 245), headMember, label("Captain leaving") + 1, label("Captain end"), 1)
  set currentMask to the number of member gMaskName
  if currentMask > 0 then
    CreateScoreRange(the maskChannel of gParadePartsList, 36, point(103, 245), point(103, 89), currentMask, label("Captain start"), label("Captain waving"), 1)
    CreateScoreRange(the maskChannel of gParadePartsList, 36, point(103, 89), point(103, 89), currentMask, label("Captain waving"), label("Captain leaving"), 1)
    CreateScoreRange(the maskChannel of gParadePartsList, 36, point(103, 89), point(103, 245), currentMask, label("Captain leaving") + 1, label("Captain end"), 1)
  end if
  set costumeLongName to gCostumeName
  delete char the number of chars in costumeLongName - 3 to the number of chars in costumeLongName of costumeLongName
  set costumeLongName to costumeLongName && "Loop"
  set currentCostume to the number of member costumeLongName
  if currentCostume > 0 then
    CreateScoreRange(the costumeChannel of gParadePartsList, 0, point(103, 290), point(103, 134), currentCostume, label("Captain start"), label("Captain waving"), 1)
    CreateScoreRange(the costumeChannel of gParadePartsList, 0, point(103, 134), point(103, 134), currentCostume, label("Captain waving"), label("Captain leaving"), 1)
    CreateScoreRange(the costumeChannel of gParadePartsList, 0, point(103, 134), point(103, 290), currentCostume, label("Captain leaving") + 1, label("Captain end"), 1)
  end if
  go(returnFrame)
end

on DeleteCaptainFromScore
  set returnFrame to the frame
  DeleteScoreRange([the headChannel of gParadePartsList, the costumeChannel of gParadePartsList, the maskChannel of gParadePartsList], label("Captain start"), label("Captain end"), 1)
  go(returnFrame)
end

on CreateScoreRange spriteChannel, spriteInkNum, beginPoint, endPoint, memberNumber, startframe, endframe, updateFlag
  beginRecording()
  if updateFlag = 1 then
    set the updateLock to 1
  end if
  set theType to the type of member memberNumber
  case theType of
    #bitmap:
      set theType to 1
    #filmLoop:
      set theType to 16
  end case
  set totalFrames to endframe - startframe + 1
  if beginPoint = endPoint then
    set positionOffset to point(0, 0)
  else
    set pointOffset to endPoint - beginPoint
    set positionOffset to pointOffset / totalFrames
  end if
  go(startframe)
  repeat with currentFrame = startframe to endframe
    set the type of sprite spriteChannel to theType
    set the memberNum of sprite spriteChannel to memberNumber
    set beginPoint to beginPoint + positionOffset
    set the loc of sprite spriteChannel to beginPoint
    set the ink of sprite spriteChannel to spriteInkNum
    updateFrame()
  end repeat
  if updateFlag = 1 then
    set the updateLock to 0
  end if
  endRecording()
end

on DeleteScoreRange spriteList, startframe, endframe, updateFlag
  beginRecording()
  if updateFlag = 1 then
    set the updateLock to 1
  end if
  go(startframe)
  repeat with currentFrame = startframe to endframe
    repeat with currentChannel in spriteList
      set the type of sprite currentChannel to 0
      set the scriptNum of sprite currentChannel to 0
    end repeat
    updateFrame()
  end repeat
  if updateFlag = 1 then
    set the updateLock to 0
  end if
  endRecording()
end
